' ********** Copyright 2016 Roku Corp.  All Rights Reserved. **********
 ' inits grid screen
 ' creates all children
 ' sets all observers
Function Init()
    ? "[GridScreen] Init"
    SetupAnalytics()
    m.top.observeField("focusedChild", "OnChildFocused")
    m.rowList = m.top.findNode("RowList")

    m.Description = m.top.findNode("Description")
    m.Background = m.top.findNode("Background")

    GoogleParams = {
    t : "pageview"
    dp : "/inicio"
    dt : "inicio"
    dh : "m3u.cl"
    dl : "https://roku.m3u.cl/inicio"
}

m.global.RSG_analytics.trackEvent = {
Google      : GoogleParams
}
End Function

' handler of focused child in GridScreen
Sub OnChildFocused()
    if m.top.isInFocusChain() and not m.rowList.hasFocus() then
        m.rowList.setFocus(true)
    end if
End Sub

Sub SetupAnalytics()
    m.global.addField("RSG_analytics","node",false)
    m.global.RSG_analytics = CreateObject("roSGNode","Roku_Analytics:AnalyticsNode")
    'disables all debug prints, enable it in order to see which events are fired
    m.global.RSG_analytics.debug = false

    ' Analytics Initialization
    m.global.RSG_analytics.init = {

        'set data to IQ analytics
        Google : {
            trackingID : "UA-97836057-5"
            defaultParams : {
                an : "RokuAnalyticsClient"
            }
        }
    }

End Sub

' handler of focused item in RowList
Sub OnItemFocused()
    itemFocused = m.top.itemFocused
    ? ">> GridScreen > OnItemFocused"; itemFocused

    'When an item gains the key focus, set to a 2-element array,
    'where element 0 contains the index of the focused row,
    'and element 1 contains the index of the focused item in that row.
    if itemFocused.Count() = 2 then
        'get content node by index from grid
        focusedContent = m.top.content.getChild(itemFocused[0]).getChild(itemFocused[1])

        if focusedContent <> invalid then
            'set focused content to top interface
            m.top.focusedContent = focusedContent

            'set content to description node
            m.Description.content = focusedContent

            'set background wallpaper
            m.Background.uri = focusedContent.hdBackgroundImageUrl
        end if
    end if
end Sub
