' ********** Copyright 2016 Roku Corp.  All Rights Reserved. **********

 sub RunUserInterface()
    screen = CreateObject("roSGScreen")
    scene = screen.CreateScene("HomeScene")
    scene.signalBeacon("AppLaunchInitiate")
    port = CreateObject("roMessagePort")
    input = CreateObject("roInput")
    screen.SetMessagePort(port)
    input.SetMessagePort(port)
    screen.Show()

    oneRow = GetApiArray()
    list = oneRow
    scene.gridContent = ParseXMLContent(list)
    scene.signalBeacon("AppLaunchComplete")


    while true
        msg = wait(0, port)
        print "------------------"
        print "msg = "; msg

        if type(msg) = "roInputEvent" and msg.isInput() then
          if msg.GetInfo().MediaType <> invalid and msg.GetInfo().ContentID <> invalid
            ProcessDeepLink(msg.GetInfo())
          end if
        end if

    end while

    if screen <> invalid then
        screen.Close()
        screen = invalid
    end if
end sub


Function ParseXMLContent(list As Object)
    RowItems = createObject("RoSGNode","ContentNode")

    for each rowAA in list
        row = createObject("RoSGNode","ContentNode")
        row.Title = rowAA.Title

        for each itemAA in rowAA.ContentList
            item = createObject("RoSGNode","ContentNode")
            ' We don't use item.setFields(itemAA) as doesn't cast streamFormat to proper value
            for each key in itemAA
                item[key] = itemAA[key]
            end for
            row.appendChild(item)
        end for
        RowItems.appendChild(row)
    end for

    return RowItems
End Function


Function GetApiArray() as Object
    url = CreateObject("roUrlTransfer")
    url.SetUrl("http://www.m3u.cl/media2.php")
    rsp = url.GetToString()

    responseXML = ParseXML(rsp)
    responseArray = responseXML.GetChildElements()

    result = []
    result2 = []
    cat = ""

    for each xmlItem in responseArray
        if xmlItem.getName() = "item"
            item = {}
            item.cat = xmlItem.getattributes().category
            item.title = xmlItem.getattributes().title
            item.url = xmlItem.getattributes().link
            item.description = xmlItem.getattributes().description
            item.streamFormat = "hls"
            item.Live = "true"
            item.ContentType = "live"
            item.HDPosterUrl = xmlItem.getattributes().thumbnail
            item.hdBackgroundImageUrl = xmlItem.getattributes().thumbnail
            if cat <> xmlItem.getattributes().category and cat <> "" then
              result2.push({
                Title : cat
                ContentList : result
              })
              result = []
            end if
            result.push(item)
            cat=xmlItem.getattributes().category
        end if
    end for
    result2.push({
      Title : cat
      ContentList : result
    })

    return result2
End Function



Function ParseXML(str As String) As dynamic
    if str = invalid return invalid
    xml = CreateObject("roXMLElement")
    if not xml.Parse(str) return invalid
    return xml
End Function
